﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;

using System.Net;
using System.Net.Sockets;

using System.Threading;

namespace VBParadiseEasyTCPChat
{
    public class Server
    {
        public IPEndPoint IPePRemote { get; set; }
        public bool KeepAlive { get; set; }

        public string WelcomeMessage = "Hello client $User";

        private TcpListener tcpListener;
        private Thread listenerThread;

        private List<Client> clientList = new List<Client>();
        private List<string> chatLog = new List<string>();

        public Server(string _ip, int _port)
        {
            IPePRemote = new IPEndPoint(IPAddress.Parse(_ip), _port);
            tcpListener = new TcpListener(IPePRemote);

            
            listenerThread = new Thread(() =>
            {
                tcpListener.Start();
                while (KeepAlive)
                {
                    var _tcpClient = tcpListener.AcceptTcpClient();

                    Client _c = new Client(_tcpClient);
                    _c.Send(WelcomeMessage.Replace("$User", _c.Receive().Split('=')[1]));

                    for (int i = 0; i < chatLog.Count; i++)
                    {
                        _c.Send("[old]: " + chatLog[i]);
                    }

                    clientList.Add(_c);

                    new Thread(new ParameterizedThreadStart((object _c0) =>
                    {
                        Client _client = (Client)_c0;

                        while (_client.tcpClient.Connected)
                        {
                            try
                            {
                                string _incoming = _client.Receive();
                                sendToAll(_incoming);
                            }
                            catch
                            {
                                clientList.Remove(_client);
                                sendToAll("User has left!");
                            }
                        }

                    })).Start(_c);

                }

            });

            

        }

        public void Start()
        {
            KeepAlive = true;
            listenerThread.Start();
        }

        private void sendToAll(string _message)
        {
            for (int i = 0; i < clientList.Count; i++)
            {
                clientList[i].Send(_message);
            }
            chatLog.Add(_message);
        }

    }


    public class Client
    {
        private StreamWriter sWriter;
        private StreamReader sReader;

        public TcpClient tcpClient;

        public Client(TcpClient _c)
        {
            tcpClient = _c;

            sWriter = new StreamWriter(tcpClient.GetStream());
            sReader = new StreamReader(tcpClient.GetStream());

            
        }

        public void Send(string _message)
        {
            sWriter.WriteLine(_message);
            sWriter.Flush();
        }

        public string Receive()
        {
            return sReader.ReadLine();
        }
    }
}
